#ifndef MSG_H
#define MSG_H
#include <stdio.h>

/*max message length */
#define MAXLEN 4096

#define MSGNAMELEN 108
/* type to store process name*/
typedef char msg_procname[MSGNAMELEN];

/* send a message */
ssize_t msg_send(char *dest, const void *buf, size_t len);

/* receive a message */
/* sender can be:
 *	NULL: receive a message from anyone, do not return the name of the sender 
 *	string: receive a message from the specified sender 
 *	an empty string stored in a msg_procname field:
 *		receive a message from anyone, store the name of the sender.
 */
ssize_t msg_recv(char *sender, void *buf, size_t len);

void msg_myname(char *myname);

/* initialize the message buffer service */
void async_msg_init(char *procname);
void sync_msg_init(char *procname);
void nb_msg_init(char *procname);

void msg_fini(void);

__attribute__((constructor)) void _msg_init();

__attribute__((destructor)) void _msg_fini();

#endif
