#include <stdio.h>
#include <unistd.h>
#include <string.h>
#include <msg.h>
#include <msgq.h>

#define MAXLEN 4096

/* SYNC2ASYNC SERVER */

void s2a_deliver(char *receiver, char* sender_payload, size_t sender_payloadlen) {
	msg_send(receiver, sender_payload, sender_payloadlen);
}

int main(int argc, char *argv[]) {
	sync_msg_init("S2AD");
	char buf[MAXLEN];
	msg_procname client;
	ssize_t msglen;

	while (1) {
		*client = 0;
		msglen = msg_recv(client, buf, MAXLEN);
		if (msglen > 0) {
			char *namearg = buf+1;
			size_t namearglen = strlen(namearg) + 1;
			char *payload = namearg + namearglen;
			msglen -= namearglen + 1;
			/* process S and R packets */
			/* case S: client is the sender, namearg the destination, payload is the message */
			/* case R: client is the receiver, namearg the desired sender (or empty) */
			switch (*buf) {
				case 'S': msgq_add(client, namearg, payload, msglen, s2a_deliver);
									break;
				case 'R': msgq_get(client, namearg, s2a_deliver);
									break;
			}
		}
	}
}


